

              import java.io.*;
              import java.net.*;
              import java.util.*;
              import netscape.security.PrivilegeManager;

              public class EchoClient {
                  public static void main(String[] args) throws IOException {

                      Socket echoSocket = null;
                      PrintWriter out = null;
                      BufferedReader in = null;

                      try {
                          setNavigatorProxyProperties();
                          echoSocket = new Socket("ferret.npac.syr.edu", 7);
                          out = new PrintWriter(echoSocket.getOutputStream(), true);
                          in = new BufferedReader(new InputStreamReader(
                                                      echoSocket.getInputStream()));
                      } catch (UnknownHostException e) {
                          System.err.println("Don't know about host: kyle.npac.syr.edu.");
                          System.exit(1);
                      } catch (IOException e) {
                          System.err.println("Couldn't get I/O for "
                                             + "the connection to: kyle.npac.syr.edu.");
                          System.exit(1);
                      }

                      BufferedReader stdIn = new BufferedReader(
                                                 new InputStreamReader(System.in));
                      String userInput;

                      while ((userInput = stdIn.readLine()) != null) {
                          out.println(userInput);
                          System.out.println("echo: " + in.readLine());
                      }

                      out.close();
                      in.close();
                      stdIn.close();
                      echoSocket.close();
                  }
              
        public static void setNavigatorProxyProperties() {
          try {
                PrivilegeManager.enablePrivilege("Debugger");
                String s = System.getProperty("network.proxy.type");
                if (s != null)
                        return;
                /*
                * Search prefs.js for proxy settings
                */
                s = System.getProperty("user.home"); 
                int i, j = s.length();
                if (s.charAt(j-1) != File.separatorChar)
                        s += File.separator;
                File f = new File(s + "prefs.js");
                if (!f.exists())
                        f = new File(s + "preferences.js");
                BufferedReader in = new BufferedReader(new FileReader(f));
                Properties pref = new Properties();
                String name;
                // Read all preferences into pref
                while ((s = in.readLine()) != null) {
                        if (s.indexOf("user_pref") < 0) 
                                continue;
                        // Parse user_pref("name", "value");
                        //    or user_pref("name", 21);
                        i = s.indexOf('"') + 1;  
                        if (i < 1) continue;
                        j = s.indexOf('"', i);
                        if (j < 0) continue;
                        name = s.substring(i, j);
                        //
                        i = s.indexOf(',', j) + 1;
                        if (i < 1) continue;
                        j = s.lastIndexOf(')');
                        if (j < i) continue;
                        s = s.substring(i, j).trim();
                        i = s.length() - 1;

                        if (i > 0 && s.charAt(0) == '"' && s.charAt(i) == '"')
                                s = s.substring(1, i);
                        pref.put(name, s);
                }
                // Get all system properties
                Properties sys = System.getProperties();
                /*
                * network.proxy.type:
                *    null  Direct connection (no proxy)
                *    1     Manual proxy configuration
                *    2     Automatic proxy configuration
                */
                s = pref.getProperty("network.proxy.type"); 
                if (s == null) s = "0";
                sys.put("network.proxy.type", s);
                if (s.equals("1")) {
                        // Set SOCKS proxy properties
                        s = pref.getProperty("network.hosts.socks_server");
                        if (s != null) sys.put("socksProxyHost", s);
                        s = pref.getProperty("network.hosts.socks_serverport");
                        if (s != null) sys.put("socksProxyPort", s);
                        // Set HTTP proxy properties
                        s = pref.getProperty("network.proxy.http");
                        if (s != null) sys.put("http.proxyHost", s);
                        s = pref.getProperty("network.proxy.http_port");
                        if (s != null) sys.put("http.proxyPort", s);
                        // Set HTTPS proxy properties
                        s = pref.getProperty("network.proxy.ssl");
                        if (s != null) sys.put("https.proxyHost", s);
                        s = pref.getProperty("network.proxy.ssl_port");
                        if (s != null) sys.put("https.proxyPort", s);
                        // Set FTP proxy properties
                        s = pref.getProperty("network.proxy.ftp");
                        if (s != null) sys.put("ftpProxyHost", s);
                        s = pref.getProperty("network.proxy.ftp_port");
                        if (s != null) sys.put("ftpProxyPort", s);
                }
                // Make it permanent
                System.setProperties(sys);  
          }
          catch (Throwable e) {}
        }
}
                        
                        
                        

